/** Restituisce il nome della classe **/

class Base {

    String name() {
	return "Base";
    }   
}

class More extends Base {

    String name() {
	return "More";
    }
 
    void printName() {
	Base sref = (Base) this;
	System.out.println("this.name() = " + this.name());
	System.out.println("sref.name() = " + sref.name());
	System.out.println("super.name() = " + super.name());
    }
}

//sref e super fanno entrambi riferimento all'oggetto istanza di Base
// solo super ignora la classe reale dell'oggetto e utilizza il metodo di Base
//sref si comporta come this; JVM seleziona l'implementazione di name in base alla classe 
//corrente dell'oggetto